* Disclaimer:
* This source code is proprietary of 
* Integrated Signal Processing Systems / RWTH-Aachen / Prof. Meyr (ISS)
* It is part of the DSPstone Benchmarking methodology
* The code, or parts of it may be used for non commercial issues
* All commercial uses require the written consent of  ISS

* file:		convolution.asm
* author:	Heiner Loellmann
* date:		17.06.99
* processor:	TMS320C54x
* project:	dsp-stone
* short description:	computes the equation
*		y=sum(i=0...N-1)of(Xi*HN-i)

	.global startp
	.global prof
	.global endp
	.mmregs

N	.set 16

	.data

x	.word 1
	.word 2
	.word 3
	.word 4
	.word 5
	.word 6
	.word 7
	.word 8
	.word 9
	.word 10
	.word 11
	.word 12
	.word 13
	.word 14
	.word 15
	.word 16

h	.word 1
	.word 2
	.word 3
	.word 4
	.word 5
	.word 6
	.word 7
	.word 8
	.word 9
	.word 10
	.word 11
	.word 12
	.word 13
	.word 14
	.word 15
	.word 16

y	.word 0	


	.text
startp:	
	STM	#x    ,AR2
	STM	#h+15 ,AR3		; pointer to hN-i
	STM	#y    ,AR4
prof:	
	RPTZ	B     , #N-1		; B = B + Xi*hN-i (B allready set to zero)
	LMS	*AR2+ , *AR3-
	STL	B     , *AR4
endp:	nop
	
	.end
