* Disclaimer:
* This source code is proprietary of 
* Integrated Signal Processing Systems / RWTH-Aachen / Prof. Meyr (ISS)
* It is part of the DSPstone Benchmarking methodology
* The code, or parts of it may be used for non commercial issues
* All commercial uses require the written consent of  ISS

* file:			dot_produtct.asm
* author :		Heiner Loellmann / Andreas Ropers
* date:			15.06.99
* project :		dsp-stone
* processor :		TMS320C54x
* short description :	computes the product of two vectors a and b,
*			which have the dimension of 2:	c=a*b , c is a scalar
*
	
	.global startp
	.global prof
	.global endp
	.mmregs			;defines global symbolic names for the registers

N	.set 2			; vector dimension

	.data

a	.word 1			; a1 (of vector a)
	.word 1 		; a2

b	.word 1			; b1 (of vector b)
	.word 2			; b2

c	.word 0			; scalar c (result)
	
	
	.text
startp:	
	STM #a	 , AR2		; pointer to a1
	STM #b	 , AR3		;            b1
	STM #c	 , AR4		;            c
prof:	
	RPTZ B   , #N-1		; for (i=1; i<=N ; i++)
	LMS *AR2+, *AR3 +	; B = B+bi*ai
	STL B    , *AR4
endp:	nop
			
	.end
