* file:		main_16_fft.asm
*
* processor:	TMS520c54x
*
* project:	dsp-stone
*
* This program is based on the book " TMS320C54x -User's Guide- " from TEXAS INSTRUMENTS
* (Preliminary 1995) P.12-51.
*
* modified by:	Heiner Loellmann / Andreas Ropers
*
* date:		07.99
*
* short description:	complex radix 2 in place, 16-point FFT with decimation in time
*
	
	.title "C54x 16-point FFT"
	.mmregs
	.global	startp
	.global prof
	.global endp
	.global	RESET
	.global	PI_4
 	.include fft.mac	; includes several macros

	.bss	SP_INIT,1
	.bss	INPUT,32
	.bss	WR,7
	.bss	WI,7
N	.set	16
PI_4	.set	23170

	
	.data
	
IN_DATA	.word	0		; IN_r(0)	real part
	.word	0		; IN_i(0)	imaginary part
	.word	1		; ...
	.word	1
	.word	2
	.word	2
	.word	3
	.word	3
	.word	4
	.word	4
	.word	5
	.word	5 
	.word	6
	.word	6
	.word	7
	.word	7
	.word	8
	.word	8
	.word	9
	.word	9
	.word	10
	.word	10
	.word	11
	.word	11
	.word	12
	.word	12
	.word	13
	.word	13
	.word	14
	.word	14
	.word	15
	.word	15	

COSINE	.word	30274
	.word	23170
	.word	12540
	.word	00000
	.word	-12540
	.word	-23170
	.word	-30274
SINE	.word	12540
	.word	23170
	.word	30274
	.word	32768
	.word	30274
	.word	23170
	.word	12540

	.sect	"vector"
RESET	BD	INIT
	STM	#SP_INIT,SP
	.space	124*16

	.text
startp:
prof:	
INIT:	LD	#1,DP
	LD	#-1,ASM
	SSBX	FRCT		; set FRCT = 1
	STM	#N,AR0		; half FFT-size (complex-FFT)
	STM	INPUT,AR5	; reverse input
	;; RPT	#N-1
	;; PRTR 1000H,*AR5+0B
	
	STM	#N-1,BRC
	STM	#IN_DATA,AR2
	RPTB	bit_rev		; read data from IN_DATA
	MVDD	*AR2+,*AR5+
	MVDD	*AR2-,*AR5+
	MAR	*AR2+0B		; storage in bit reversed order
bit_rev	NOP
	
	STM	#WR,AR2		; WR = sine
	RPT	#6		; input sine
	MVPD	COSINE,*AR2+
	STM	#WI,AR5
	RPT	#6
	MVPD	SINE,*AR5+

	STM	#7,AR0		; INDEX REGISTER
	STM	#INPUT,AR2	; POINT TO R1
	STM	#INPUT+2,AR3	; POINT TO R2
	STM	#INPUT+4,AR4	; POINT TO R3
	STM	#INPUT+6,AR5	; POINT TO R4

 	COMBO	4
	STM	#3,AR0		; INDEX REGISTER
	STM	#INPUT,AR3	; POINT TO R1
	STM	#INPUT+8,AR4	; POINT TO R2

 	STAGE3	2
	STM	#INPUT,AR3	; POINT TO PR
	STM	#INPUT+16,AR4	; POINT TO QI
	STM	#WR,AR2		; POINT TO COS
	STM	#WI,AR5		; POINT TO SIN

 	do_loops 7
 	ex_btfly
endp:	
NEXT	B	NEXT		; endless loop
