* Disclaimer:
* This source code is proprietary of 
* Integrated Signal Processing Systems / RWTH-Aachen / Prof. Meyr (ISS)
* It is part of the DSPstone Benchmarking methodology
* The code, or parts of it may be used for non commercial issues
* All commercial uses require the written consent of  ISS

* file:			fir_2.asm
* author:		Heiner Loellamnn / Andreas Ropers
* date:			18.06.1999
* project:		dsp-stone
* processor:		TMS320C54x
* short description :	the programm evaluates the FIR-response y(k):	
*			y(k) = sum(i=0...N-1)of( x(k-i)*h(i) )
*			while updating the delay line of x
* remark:		Alternativ version of fir.asm which will NOT be used within the 
*			benchmark test!	        
*			This program updates the delay line of x by moving each element
*		        which causes extra instructions. The advantage will be, that the
*			contens of the auxiliary registers (current offset) has not to be
*			pushed on STACK before return instruction.


	.global startp
	.global endp
	.mmregs
	
N	.set 4			; number of FIR taps (<=> array-length of h and x) 

	.data

h	.word 1			; h(1) ...
	.word 2			
	.word 3
	.word 4			; h(N)

x	.word 1			; x(k) .....
	.word 2
	.word 3			; x(k-(N-2))
	.word 4			; x(k-(N-1))

y	.word 0			; y(k)
	
new_val	.word 8			; next input sample x(k)


	.text
startp:	
	STM  #y    , AR1
	STM  #x+2  , AR2	; pointer to x(k-(N-2))
	STM  #x+3  , AR3	; pointer to x(k-(N-1))
	STM  #new_val, AR4
	STM  #h    , AR5

	LD   #0    , B
	STM  #N-2  , BRC
	RPTB loop		; for i=0...N-2 do {
	LMS  *AR5+ , *AR3	; B = B+h(i)*x(k-(N-1)+i)
loop	MVDD *AR2- , *AR3-	; x(k-(N-1)+i)=x(k-(N-1)+i+1)  }

	LMS  *AR5  , *AR3	; the last iteration:	h(N)*x(k)
	MVDD *AR4  , *AR3	; storage of the new input sample x(k)
	STL  B     , *AR1	; B -> y(k)
endp:	
	.end
	
	
