* Disclaimer:
* This source code is proprietary of 
* Integrated Signal Processing Systems / RWTH-Aachen / Prof. Meyr (ISS)
* It is part of the DSPstone Benchmarking methodology
* The code, or parts of it may be used for non commercial issues
* All commercial uses require the written consent of  ISS

* file:			matrix_1x3.asm
* author:		Heiner Loellmann/ Andreas Ropers

* date:			16.06.99
* project:		dsp-stone
* processor:		TMS320C54x
* short description:	evaluation of a 3x3 matrix  H*X=Y
*
*
*		( h11 h12 h13 )	  ( x1 )   ( y1 )
*		( h21 h22 h23 ) * ( x2 ) = ( y2 )
*		( h31 h32 h33 )   ( x3 )   ( y3 )
* remark:		This version uses no circular address modification
*			It is an alternativ to matrix_1x3, which will NOT be
*			used within the benchmark tests!
	
	.global startp
	.global endp
	.mmregs

dim	.set 3

	.data

X	.word 1			; x1  
	.word 2			; x2
	.word 3			; x3

H	.word 1			; h11
	.word 2			; h12
	.word 3			; h13
	.word 4			; h21
	.word 5			; h22
	.word 6			; h23
	.word 7			; h31
	.word 8			; h32
	.word 9			; h33

Y	.word 0			; y1
	.word 0			; y2
	.word 0			; y3


	.text
startp:	
	STM	#H     , AR3
	STM	#Y     , AR4
	
	STM	#dim-1 , BRC
	RPTB	loop		; for(i=1; i<=N; i++) {

	STM	#X    , AR2
	RPTZ	B     , #dim-1	; for(k=1; k<=N; k++) 
	LMS	*AR3+ , *AR2+ 	; B = B+hik*xk

loop	STL	B     , *AR4+	; B -> yi             }
endp:	 
	.end

* reslut: Y=(E,20,32)
