* Disclaimer:
* This source code is proprietary of 
* Integrated Signal Processing Systems / RWTH-Aachen / Prof. Meyr (ISS)
* It is part of the DSPstone Benchmarking methodology
* The code, or parts of it may be used for non commercial issues
* All commercial uses require the written consent of  ISS

* file:			n_real_update.asm
* author :		Heiner Loellmann/ Andreas Ropers

* date:			15.06.99
* project :		dsp-stone
* processor :		TMS320C54x
* short description :	This program updates an array of N real data
*			with the operation di=ci+ai*bi ,
*			index i in the range of 1<=i<=N
 
	
	.global startp
	.global endp
	.mmregs			;defines global symbolic names for the registers

N	.set 4			; number of items 

	.data

A	.word 1			; a(0)
	.word 1 		
	.word 1
	.word 1			; a(N-1)

B	.word 1
	.word 2
	.word 3
	.word 4

C	.word 1
	.word 1
	.word 1
	.word 1

D	.word 0
	.word 0
	.word 0
	.word 0
	
	.text
startp:	
	STM #A,AR2
	STM #B,AR3
	STM #C,AR4
	STM #D,AR5

	STM #N-1,BRC
	RPTB loop		; for (i=1; i<=N; i++)
	LD *AR4+  , B		; ci -> B
	LMS *AR2+ , *AR3+	; B = B+ai*bi
loop	STL B     ,*AR5+	; B -> di
endp:			
	.end
